
; converts rArg0 from char to bin (4 bit)
BCH2Bin4:
	subi rArg0, '0'
	cpi rArg0, 10
	brlo BCH2Bin4_a
	
	subi rArg0, -'0'+'A'-10
	cpi rArg0, 16
	brlo BCH2Bin4_a
	
	subi rArg0, -'A'+'a'
	cpi rArg0, 16
	brlo BCH2Bin4_a
	
		;invalid character
		clr rArg0
BCH2Bin4_a:
	ret


; good Functions

Bin2BCH8:
	mov rArg1, rArg0
	swap rArg1
	andi rArg1, 0x0F
	andi rArg0, 0x0F
	cpi rArg0, 10
	brlo NormalNumber1
		subi rArg0, -'A'+'0'+10
NormalNumber1:
	subi rArg0, -'0'
	cpi rArg1, 10
	brlo NormalNumber2
		subi rArg1, -'A'+'0'+10
NormalNumber2:
	subi rArg1, -'0'
	ret

	
Bin2BCD8:
	;input rArg0
	;output rTemp1:rTemp0
	clr rArg1
Bin2BCD8a:
	subi rArg0, 10
	inc rArg1
	brcc Bin2BCD8a
	subi rArg0, -10
	dec rArg1
	ret	


; this initializes the output stream / input stream
uart_init:
	;initialize baud-rate-register
	ldi rArg0, low(F_CPU/(8*F_BAUD) -1)
	out UBRRL, rArg0
	ldi rArg0, high(F_CPU/(8*F_BAUD) -1) & ~(1<<URSEL)
	out UBRRH, rArg0
	
	;initialize the interrupts
	ldi rArg0, (1<<U2X)
	out UCSRA, rArg0
	ldi rArg0, (1<<RXCIE) | (1<<RXEN) | (1<<TXEN)
	out UCSRB, rArg0
	ldi rArg0, (1<<URSEL) | (1<<UCSZ1) | (1<<UCSZ0)		; 8 bit
	out UCSRC, rArg0
	
	;initialize the output&input pins...
	sbi DDRD, PD1
	cbi DDRD, PD0
	ret

