.include "m32def.inc"

; This file was written by Clemens Helfmeier
; if you find any bugs or errors, please let me know at:
; ClemensHelfmeier (at) gmx (dot) de
;



.equ	F_CPU		= 14318180 ;5Mhz
.equ	F_BAUD		= 57600

.def	rArg0		= r16
.def	rArg1		= r17
.def	rArg2		= r18
.def	rTemp0		= r19
.def	rTemp1		= r20
.def	rTemp2		= r21
.def	rTemp3		= r22

.cseg
.org 0x0000
.org 0x00
	rjmp Main
.org URXCaddr
	reti ;rjmp URXCInt
	
#include "macros.asm"
#include "jtag.asm"
#include "svf.asm"

Main:
	ldi rArg0, low(RAMEND)
	out SPL, rArg0
	ldi rArg0, high(RAMEND)
	out SPH, rArg0
	
	
	rcall uart_init
	rcall jtag_init
	rcall svf_init
	; interrupts an:
	sei

	
	rjmp svf_Reciever
	
