
.macro svf_MemDump
	rcall svf_MemDumpFunction
.endm
.macro svf_dbgSendReg
	push rArg0
	push rArg1
	mov rArg0, @0
	rcall Bin2BCH8
	svf_dbgSendPureReg rArg1
	svf_dbgSendPureReg rArg0
	pop rArg1
	pop rArg0
.endm
.macro svf_dbgSendChar
	push rArg0
	ldi rArg0, @0
svf_dbgSendChar0:
	sbis UCSRA, UDRE
		rjmp svf_dbgSendChar0
	out UDR, rArg0
	pop rArg0
.endm
.macro svf_dbgSendPureReg
svf_dbgSendPureRega:
	sbis UCSRA, UDRE
		rjmp svf_dbgSendPureRega
	out UDR, @0
.endm

svf_MemDumpFunction:
	; output the memory
	svf_ldi16 zl, zh, svf_MiscBase
	ldi rArg1, 0x10
	rcall svf_MemDumpFunction_a
	svf_dbgSendChar '\n'
	ldi rArg1, 0x10
	rcall svf_MemDumpFunction_a
	svf_dbgSendChar '\n'
	ldi rArg2, 6
svf_MemDumpFunction_b:
		ldi rArg1, 1
		rcall svf_MemDumpFunction_a
		svf_dbgSendChar ' '
		ldi rArg1, svf_RegLength
		rcall svf_MemDumpFunction_a
		svf_dbgSendChar ' '
		ldi rArg1, svf_RegLength
		rcall svf_MemDumpFunction_a
		svf_dbgSendChar ' '
		ldi rArg1, svf_RegLength
		rcall svf_MemDumpFunction_a
		svf_dbgSendChar ' '
		ldi rArg1, 1
		rcall svf_MemDumpFunction_a
		svf_dbgSendChar '\n'
		dec rArg2
	brne svf_MemDumpFunction_b
	ret

svf_MemDumpFunction_a:
		ld rArg0, z+
		svf_dbgSendReg rArg0
		dec rArg1
	brne svf_MemDumpFunction_a
	ret
	
	
svf_dbgComment:
	.db "Comment\n"
svf_dbgUnknownCommand:
	.db "Unknown Command\n"
svf_dbgUnknownState:
	.db "Unknown State\n"